
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

unsigned int ticks, i;
char *str_buf, fl_12, sreg;
unsigned char integer[6];

interrupt [9] void timer1_ovf_isr(void)
{

}

interrupt [6] void timer1_capt_isr(void)
{

} 

interrupt [17] void ana_comp_isr(void)
{

fl_12=5;

}

unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (0x00 & 0xff);
delay_us(10);
ADCSRA|=0x40;
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

void USART_Init (unsigned int ubrr)
{
UBRRH=(unsigned char)(ubrr>>8);
UBRRL=(unsigned char) ubrr;
UCSRB=(1<<3);
UCSRC=(1<<7)|(1<<3)|(3<<1);
}

void init(void)
{
PORTC=0x00;
DDRC=0x06;
PORTD=0x00;
DDRD=0;
TCCR1A=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
TIMSK=0;
ACSR=0x4E;
SFIOR=0x00;
ADMUX=0x00 & 0xff;
ADCSRA=0x87;
}

void LcdInt (unsigned int num)
{                   
char pucha;

pucha = 48+ num / 10000;
num = num % 10000;
if (pucha) integer[0]=pucha;
else integer[0]=' ';
pucha = 48+ num / 1000;
num = num % 1000;
if (pucha) integer[1]=pucha;
else integer[1]=' ';
pucha = 48+ num / 100;
num = num % 100;
if (pucha) integer[2]=pucha;
else integer[2]=' ';
pucha = 48+ num / 10;
num = num % 10;
if (pucha) integer[3]=pucha;
else integer[3]=' ';
pucha = 48+ num;
num = num % 1;
if (pucha) integer[4]=pucha;
else integer[4]=' '; 
}

void main(void)
{
#asm("sei")
USART_Init(14745600/16/57600-1);
init();

fl_12=3;
while (1)
{

if (fl_12==3) 
{
putsf("3333");
PORTC|=(1<<2);; 
delay_ms (100);
PORTC&=(0<<2);; 
delay_ms(10);

PORTC|=(1<<1); ; 
TCCR1B=0x00;
TCNT1=0;
TCCR1B=1;
fl_12=2;
};
while(ACSR.5) {};
if (fl_12 == 5)
{

putsf("2222");

PORTC&=(0<<1); ;
TCCR1B=0;
ticks=TCNT1;
fl_12=3;
itoa(ticks, str_buf);
puts(str_buf);
putsf("\n\r");

}; 
};
}
